import os, subprocess, re

dirs = ["assets", "artsrc", "src"]
p4user = "Mike"
p4client = "Mike_All"
p4port = "localhost:1666"
p4statcommand = "p4 -p %s -u %s -c %s fstat \"%%s\"" % (p4port, p4user, p4client)
p4addcommand = "p4 -p %s -u %s -c %s add \"%%s\"" % (p4port, p4user, p4client)
extensions_to_ignore = ['.lnk']


def run_command(cmd):
    return subprocess.Popen(cmd, stdout=subprocess.PIPE, stderr=subprocess.PIPE, shell=True).communicate()

def add_to_source_control(pathtofile):
    (stdout, stderr)  = run_command(p4addcommand % pathtofile)
    if len(stderr)==0:
        print stdout
    else:
        print stderr        
    
def file_under_source_control(pathtofile):
    (stdout, stderr)  = run_command(p4statcommand % pathtofile)
    return -1 == stderr.find("no such file(s)")

for dir in dirs:
    for root, dirs, files in os.walk(dir):
        for file in files:
            (without_ext, ext) = os.path.splitext(file)
            if not ext in extensions_to_ignore:
                pathtofile = os.path.join(root, file)
                if not file_under_source_control(pathtofile):
                    add_to_source_control(pathtofile)
