﻿package meyermike
{
    import flash.display.DisplayObjectContainer;
    import flash.display.Sprite;

    /**
     * ...
     * @author Mike Meyer
     */
    public class Layers
    {
        public static var BackgroundLayer:GameObjectHolder;
        public static var EnemyLayer:GameObjectHolder;
        public static var PlatformLayer:GameObjectHolder;
        public static var PlayerLayer:GameObjectHolder;
        public static var ItemLayer:GameObjectHolder;
        public static var UILayer:GameObjectHolder;
        public static var NPCLayer:GameObjectHolder;
        public static var BloodLayer:GameObjectHolder;

        private static var mLayers:/*GameObjectHolder*/Array;

        /**
         * call beat on all the layers
         */
        public static function Beat(beat:Number):void
        {
            for (var i:Number = 0; i < mLayers.length; ++i)
            {
                mLayers[i].Beat(beat);
            }
        }

        /**
         * call beat on all the layers
         */
        public static function OffBeat(beat:Number):void
        {
            for (var i:Number = 0; i < mLayers.length; ++i)
            {
                mLayers[i].OffBeat(beat);
            }
        }

        /**
         * call QuarterBeat on each layer
         */
        public static function QuarterBeat(quarterbeat:Number):void
        {
            for (var i:Number = 0; i < mLayers.length; ++i)
            {
                mLayers[i].QuarterBeat(quarterbeat);
            }
        }

        /**
         * call RemoveAll on each layer
         */
        public static function RemoveAll():void
        {
            for (var i:Number = 0; i < mLayers.length; ++i)
            {
                mLayers[i].RemoveAll();
            }
        }

        /**
         * call Update on each layer
         */
        public static function Update():void
        {
            for (var i:Number = 0; i < mLayers.length; ++i)
            {
                mLayers[i].Update(Time.TimeDelta);
            }
        }

        /**
         * call Integrate on each layer
         */
        public static function Integrate():void
        {
            for (var i:Number = 0; i < mLayers.length; ++i)
            {
                mLayers[i].Integrate();
            }
        }

        /**
         * call after all the final positions have been figured
         * just before drawing.
         * Calls PreDraw on each layer.
         */
        public static function PreDraw():void
        {
            for (var i:Number = 0; i < mLayers.length; ++i)
            {
                mLayers[i].PreDraw();
            }
        }

        /**
         * needs to be called once so that we can attach
         * the layers to the right container
         */
        public static function CreateLayers(container:DisplayObjectContainer):void
        {
            Layers.BackgroundLayer = AddLayer(container);
            Layers.EnemyLayer = AddLayer(container);
            Layers.PlatformLayer = AddLayer(container)
            Layers.NPCLayer = AddLayer(container);
            Layers.PlayerLayer = AddLayer(container);
            Layers.ItemLayer = AddLayer(container);
            Layers.BloodLayer = AddLayer(container);
            Layers.UILayer = AddLayer(container);
        }


        /**
         * create a layer and add it to the scene graph and layer list
         */
        private static function AddLayer(container:DisplayObjectContainer):GameObjectHolder
        {
            if (null == mLayers) { mLayers = new Array(); }

            var layer:DisplayObjectContainer = new Sprite();
            container.addChild(layer);
            var goh:GameObjectHolder = new GameObjectHolder(layer)
            mLayers.push(goh);
            return goh;
        }

        /**
         * NO TIME FOR GOOD FUNCTION NAMES
         * for each thing in layer A, for each thing in layer B if call func like so
         *   func(thingFromLayerA, thingFromLayerB);
         */
        public static function ForEachCartesianProductStyle(a:GameObjectHolder, b:GameObjectHolder, func:Function):void
        {
            for (var a_index:Number = 0; a_index < a.GetObjects().length; ++a_index)
            {
                var a_go:GameObject = a.GetObjects()[a_index];

                for (var b_index:Number = 0; b_index < b.GetObjects().length; ++b_index)
                {
                    var b_go:GameObject = b.GetObjects()[b_index];

                    func(a_go, b_go);
                }
            }
        }
    }
}
