﻿package meyermike.gamespecific
{
    import flash.display.DisplayObject;
    import flash.display.Sprite;
    import meyermike.PlatformerCharacter;
    /**
     * ...
     * @author Mike Meyer
     */
    public class Item extends PlatformerCharacter
    {
        private const WIDTH:Number = 18;
        private const HEIGHT:Number = 24;

        private const DEATH_FLOAT_SPEED:Number = -400;
        private const DEATH_DURATION:Number = 1;

        [Embed(source='../../../assets/coin.png')]
        private const CoinImage:Class;

        private var mGraphic:DisplayObject;

        private var mDeathTimer:Number;

        public override function Init():void
        {
            super.Init();

            CreateGraphics();
            Restart();
        }

        protected function CreateGraphics():void
        {
            if (null == mGraphic)
            {
                mGraphic = new CoinImage();
                mGraphic.x = -0.5 * mGraphic.width;
                mGraphic.y = -0.5 * mGraphic.height;
                this.addChild(mGraphic);
            }
        }

        /**
         * react to beign collected
         */
        public function Collected():void
        {
            if (!Dying)
            {
                Dying = true;
                PhysicsEnabled = false;
                mDeathTimer = 0;

                this.dy = DEATH_FLOAT_SPEED;
            }
        }

        /**
         * set initial values after spawning
         */
        protected override function Restart():void
        {
            super.Restart();
            this.dx = 0.0;
            this.dy = 0.0;
            this.scaleX = 1.0;
            this.scaleY = 1.0;
            this.mDeathTimer = 0.0;
            this.alpha = 1;
            this.PhysicsEnabled = false;
        }

        /**
         * per-frame update
         */
        public override function Update(elapsedTime:Number):void
        {
            if (Dying)
            {
                mDeathTimer += elapsedTime;
                this.alpha = 1 - (mDeathTimer / DEATH_DURATION);
                this.scaleX = Math.cos( mDeathTimer * 8.0 * Math.PI );
            }
        }

        /**
         * dead GOs can be removed from the scene
         */
        public override function IsAlive():Boolean
        {
            return mDeathTimer < DEATH_DURATION;
        }
    }
}
