﻿package meyermike.gamespecific
{
    import flash.events.Event;
    import flash.events.EventDispatcher;
    import flash.media.Sound;
    import flash.media.SoundChannel;
    import flash.media.SoundLoaderContext;
    import flash.media.SoundTransform;
    import flash.net.URLRequest;
    import flash.utils.Timer;
    import meyermike.music.MusicEvent;
    import meyermike.music.Song;
    import meyermike.Util;

    /**
     * ...
     * @author Mike Meyer
     */
    public class Music extends EventDispatcher
    {
        private const mSongUrlPrefix:String = "http://www.meyermike.com/games/minild11/music/";
        private const mSongList:Array = [
            new Song( mSongUrlPrefix + "AnAnthemForWinterchip.mp3",
                      "An Anthem For Winderchip (Atari Pokey)",
                      "By kulor",
                      "http://8bitcollective.com/members/kulor/"),
            new Song( mSongUrlPrefix + "SeeYouNextYear.mp3",
                      "See You Next Year (Sega Genesis Turbo-FM)",
                      "By kulor",
                      "http://8bitcollective.com/members/kulor/"),
            new Song( mSongUrlPrefix + "TouchFuzzyGetDizzyLvl2.mp3",
                      "Touch Fuzzy, Get Dizzy!",
                      "By cy9ez",
                      "http://8bitcollective.com/members/cy9ez/"),
            new Song( mSongUrlPrefix + "FRIENDS.mp3",
                      "FRIENDS",
                      "By swampyboy",
                      "http://8bitcollective.com/members/swampyboy/"),
            new Song( mSongUrlPrefix + "Yerzmyey-16Kb_tune_2.mp3",
                      "16Kb tune 2",
                      "By yerzmyey",
                      "http://8bitcollective.com/members/yerzmyey/") ];

        private var mMusic:Sound;
        private var mMusicChannel:SoundChannel;
        private var mPausePosition:Number;

        private static var _inst:Music = new Music();
        public static function get inst():Music { return _inst; }

        public function StartNewMusic(e:Event = null):void
        {
            if (null != mMusicChannel)
            {
                mMusicChannel.stop();
            }

            if (mSongList.length > 0)
            {
                mMusic = new Sound();
                var song:Song = Util.RandomOneOf(mSongList);
                var file:String = song.url;
                var request:URLRequest = new URLRequest(file);
                var context:SoundLoaderContext = new SoundLoaderContext(8000, true);
                mMusic.load(request, context);

                dispatchEvent(new MusicEvent(MusicEvent.EVENT_NEW_SONG, song));

                LoopMusic();
            }
        }

        private function LoopMusic(e:Event = null, position:Number = 0):void
        {
            if (null != mMusic)
            {
                StopMusic();

                mMusicChannel = mMusic.play(position, 1, new SoundTransform(0.5) );
                mMusicChannel.addEventListener(Event.SOUND_COMPLETE, StartNewMusic);
            }
        }


        public function StopMusic():void
        {
            if (null != mMusicChannel)
            {
                mMusicChannel.removeEventListener(Event.SOUND_COMPLETE, LoopMusic);
                mMusicChannel.stop();
                mMusicChannel = null;
            }

            mPausePosition = 0;
        }

        public function Pause():void
        {
            if (null != mMusicChannel)
            {
                mPausePosition = mMusicChannel.position;
                mMusicChannel.stop();
                mMusicChannel = null;
            }
        }

        public function Resume():void
        {
            LoopMusic(null, mPausePosition);
        }
    }

}
