﻿package meyermike.gamespecific.scripts
{
    import flash.events.Event;
    import flash.events.MouseEvent;
    import meyermike.GameInterface;
    import meyermike.GameObject;
    import meyermike.gamespecific.Constants;
    import meyermike.gamespecific.Music;
    import meyermike.Layers;
    import meyermike.script.Script;
    import meyermike.script.Step;
    import meyermike.script.step.Loop;
    import meyermike.script.step.RunFunc;
    import meyermike.script.step.Wait;
    import meyermike.Util;
    import meyermike.widget.PulsingTextButton;
    import meyermike.widget.TextField;

    /**
     * ...
     * @author Mike Meyer
     */
    public class Intro extends Script
    {
        [Embed(source='../../../../assets/sky.png')]
        private const BackgroundImage:Class;

        private var mStartButton:PulsingTextButton;

        /**
         * initial setup
         */
        public override function Begin(game:GameInterface):void
        {
            super.Begin(game);

            AddTitle();
            AddPressStartMsg();

            var bg:GameObject = Layers.BackgroundLayer.Add(GameObject);
            bg.addChild(new BackgroundImage());
        }

        /**
         * clean up
         */
        public override function End():void
        {
            super.End();
            mStartButton.removeEventListener(MouseEvent.CLICK, MouseClick);
            Layers.RemoveAll();
        }

        /**
         * respond to mouse click
         */
        private function MouseClick(e:Event = null):void
        {
            mGame.SwitchToScript(new Game());
        }

        /**
         * Add the title text
         */
        private function AddTitle():void
        {
            Util.AddTextfield("Brickplacer",    0.05, 0.7, 36);
            Util.AddTextfield("", 0.05, 0.75, 36);
        }

        /**
         *
         */
        private function AddPressStartMsg():void
        {
            mStartButton = Layers.UILayer.Add(PulsingTextButton) as PulsingTextButton;
            mStartButton.SetText("click to start");
            mStartButton.SetFont(Constants.GAME_FONT);
            mStartButton.SetFontSize(36);
            mStartButton.SetFontColor(Constants.FONT_COLOR);
            mStartButton.SetHoverColor(Constants.HIGHLIGHT_COLOR);
            mStartButton.CenterOn(
                0.6 * mGame.GetStage().stageWidth,
                0.95 * mGame.GetStage().stageHeight);
            mStartButton.addEventListener(MouseEvent.CLICK, MouseClick);
        }
    }
}
