﻿package meyermike.minild10
{
    import flash.display.Bitmap;
    import flash.display.Sprite;

    /**
     * ...
     * @author Mike Meyer
     */
    public class CharacterRunAnimation extends Sprite
    {
        [Embed(source='../../../assets/character_walk1.png')]
        private static var Frame1GraphicClass:Class;
        [Embed(source='../../../assets/character_idle.png')]
        private static var Frame2GraphicClass:Class;
        [Embed(source='../../../assets/character_walk3.png')]
        private static var Frame3GraphicClass:Class;
        [Embed(source='../../../assets/character_idle.png')]
        private static var Frame4GraphicClass:Class;

        private static const FRAME_LENGTH:Number = 0.25;
        private static const NUM_FRAMES:uint = 4;
        private var mAnimTimer:Number;

        private var mFrame1:Bitmap;
        private var mFrame2:Bitmap;
        private var mFrame3:Bitmap;
        private var mFrame4:Bitmap;

        private var mCurFrame:uint;

        public function CharacterRunAnimation()
        {
            mCurFrame = 0;
            mAnimTimer = 0;
            CreateGraphics();
        }

        /**
         * create the bitmaps
         */
        public function CreateGraphics():void
        {
            mFrame1 = new Frame1GraphicClass();
            mFrame2 = new Frame2GraphicClass();
            mFrame3 = new Frame3GraphicClass();
            mFrame4 = new Frame4GraphicClass();

            var frames:Array = [mFrame1, mFrame2, mFrame3, mFrame4];
            for each (var frameGraphic:Bitmap in frames)
            {
                frameGraphic.smoothing = false;
                frameGraphic.scaleX = 2.0;
                frameGraphic.scaleY = 2.0;
                frameGraphic.x = -0.5 * frameGraphic.width;
                frameGraphic.y = -0.5 * frameGraphic.height;
                this.addChild(frameGraphic);
            }
        }

        /**
         * per-frame update
         * @param	elapsedTime - time since the last frame
         */
        public function Update(elapsedTime:Number):void
        {
            mAnimTimer -= elapsedTime;

            if (mAnimTimer <= 0.0)
            {
                mAnimTimer = FRAME_LENGTH;
                mCurFrame = (mCurFrame + 1) % NUM_FRAMES;
                SwitchFrame(mCurFrame);
            }
        }

        /**
         * make the right anim frame graphic visible
         */
        private function SwitchFrame(frame:uint):void
        {
            mFrame1.visible = false;
            mFrame2.visible = false;
            mFrame3.visible = false;
            mFrame4.visible = false;

            switch(frame)
            {
                case 0:
                    mFrame1.visible = true;
                    break;
                case 1:
                    mFrame2.visible = true;
                    break;
                case 2:
                    mFrame3.visible = true;
                    break;
                case 3:
                    mFrame4.visible = true;
                    break;
            }
        }
    }

}
