﻿package meyermike.minild10.scripts
{
    import adobe.utils.CustomActions;
    import flash.display.DisplayObject;
    import flash.display.Sprite;
    import flash.events.Event;
    import flash.events.MouseEvent;
    import flash.geom.Rectangle;
    import meyermike.collision.CollisionInfo;
    import meyermike.constants.Colors;
    import meyermike.GameInterface;
    import meyermike.GameObject;
    import meyermike.Layers;
    import meyermike.minild10.Constants;
    import meyermike.minild10.Enemy;
    import meyermike.minild10.Family;
    import meyermike.minild10.MiniLD10Character;
    import meyermike.minild10.Physics;
    import meyermike.minild10.Player;
    import meyermike.minild9.Blood;
    import meyermike.PlatformerCharacter;
    import meyermike.script.Script;
    import meyermike.script.Step;
    import meyermike.script.step.CreateGameObjectFromBitmap;
    import meyermike.script.step.Loop;
    import meyermike.script.step.SpawnGameObject;
    import meyermike.script.step.Wait;
    import meyermike.Util;
    import meyermike.Time;
    import meyermike.widget.TextField;

    /**
     * ...
     * @author Mike Meyer
     */
    public class Intro extends Script
    {
        private var mTextFields:/*TextField*/Array;

        [Embed(source = '../../../../assets/Fonts/DisposableDroidBB.ttf', fontFamily='TimerFont')]
        private static var Font:Class;

        public function Intro()
        {
            this.mBeatsPerMinute = 60.0;
            super();
        }

        /**
         * initial setup
         */
        public override function Begin(game:GameInterface):void
        {
            super.Begin(game);

            // Doing this now because other states do not
            mGame.SetCameraFollowTarget(null);
            mGame.ResetScrolling();
            Layers.RemoveAll();

            mGame.GetDisplayObjectContainer().stage.addEventListener(MouseEvent.CLICK, MouseClick);

            // $HACK - adding these above the scrolling area

            mTextFields = new Array();

            textField = new meyermike.widget.TextField();
            mGame.GetDisplayObjectContainer().addChild(textField);
            textField.SetText("Punch the");
            textField.SetFont("TimerFont");
            textField.SetFontSize(88);
            textField.SetFontColor(Colors.WHITE_ENOUGH);
            textField.CenterOn(0.50 * Constants.STAGE_WIDTH, 0.15 * Constants.STAGE_HEIGHT);
            mTextFields.push(textField);
            textField = new meyermike.widget.TextField();

            textField = new meyermike.widget.TextField();
            mGame.GetDisplayObjectContainer().addChild(textField);
            textField.SetText("Red Ones");
            textField.SetFont("TimerFont");
            textField.SetFontSize(88);
            textField.SetFontColor(Colors.WHITE_ENOUGH);
            textField.CenterOn(0.50 * Constants.STAGE_WIDTH, 0.35 * Constants.STAGE_HEIGHT);
            mTextFields.push(textField);
            textField = new meyermike.widget.TextField();

            textField = new meyermike.widget.TextField();
            mGame.GetDisplayObjectContainer().addChild(textField);
            textField.SetText("Only");
            textField.SetFont("TimerFont");
            textField.SetFontSize(88);
            textField.SetFontColor(Colors.WHITE_ENOUGH);
            textField.CenterOn(0.50 * Constants.STAGE_WIDTH, 0.55 * Constants.STAGE_HEIGHT);
            mTextFields.push(textField);
            textField = new meyermike.widget.TextField();

            textField = new meyermike.widget.TextField();
            mGame.GetDisplayObjectContainer().addChild(textField);
            textField.SetText("Click to Start");
            textField.SetFont("TimerFont");
            textField.SetFontSize(24);
            textField.SetFontColor(Colors.WHITE_ENOUGH);
            textField.CenterOn( 0.25 * Constants.STAGE_WIDTH, 0.75 * Constants.STAGE_HEIGHT);
            mTextFields.push(textField);

            var textField:TextField = new meyermike.widget.TextField();
            mGame.GetDisplayObjectContainer().addChild(textField);
            textField.SetText("Controls:  Left, Right, Z, X");
            textField.SetFont("TimerFont");
            textField.SetFontSize(18);
            textField.SetFontColor(Colors.WHITE_ENOUGH);
            textField.x = 0.5 * Constants.STAGE_WIDTH;
            textField.y = 0.80 * Constants.STAGE_HEIGHT;
            mTextFields.push(textField);

            textField = new meyermike.widget.TextField();
            mGame.GetDisplayObjectContainer().addChild(textField);
            textField.SetText("alternatively:  Left, Right, Shift, Ctrl");
            textField.SetFont("TimerFont");
            textField.SetFontSize(14);
            textField.SetFontColor(Colors.WHITE_ENOUGH);
            textField.x = 0.5 * Constants.STAGE_WIDTH;
            textField.y = 0.86 * Constants.STAGE_HEIGHT;
            mTextFields.push(textField);

            textField = new meyermike.widget.TextField();
            mGame.GetDisplayObjectContainer().addChild(textField);
            textField.SetText("or:  Left, Right, Up, Down");
            textField.SetFont("TimerFont");
            textField.SetFontSize(14);
            textField.SetFontColor(Colors.WHITE_ENOUGH);
            textField.x = 0.5 * Constants.STAGE_WIDTH;
            textField.y = 0.90 * Constants.STAGE_HEIGHT;
            mTextFields.push(textField);
        }

        /**
         * clean up
         */
        public override function End():void
        {
            super.End();

            mGame.GetDisplayObjectContainer().stage.removeEventListener(MouseEvent.CLICK, MouseClick);

            for each (var textField:TextField in mTextFields)
            {
                mGame.GetDisplayObjectContainer().removeChild(textField);
            }
            mTextFields = null;
        }

        /**
         * respond to mouse click
         */
        private function MouseClick(e:Event = null):void
        {
            mGame.SwitchToScript(new Game());
        }
    }
}
