﻿package meyermike.minild10.scripts
{
    import flash.display.DisplayObject;
    import flash.display.Sprite;
    import flash.events.Event;
    import flash.geom.Rectangle;
    import meyermike.collision.CollisionInfo;
    import meyermike.constants.Colors;
    import meyermike.GameInterface;
    import meyermike.GameObject;
    import meyermike.Layers;
    import meyermike.minild10.Constants;
    import meyermike.minild10.Enemy;
    import meyermike.minild10.Family;
    import meyermike.minild10.MiniLD10Character;
    import meyermike.minild10.Physics;
    import meyermike.minild10.Player;
    import meyermike.minild9.Blood;
    import meyermike.PlatformerCharacter;
    import meyermike.script.Script;
    import meyermike.script.Step;
    import meyermike.script.step.CreateGameObjectFromBitmap;
    import meyermike.script.step.Loop;
    import meyermike.script.step.RunFunc;
    import meyermike.script.step.SpawnGameObject;
    import meyermike.script.step.Wait;
    import meyermike.Util;
    import meyermike.Time;
    import meyermike.widget.TextField;

    /**
     * ...
     * @author Mike Meyer
     */
    public class Lose extends Script
    {
        private var mZoom:Number;

        public function Lose()
        {
            this.mBeatsPerMinute = 60.0;
            super();
        }

        /**
         * initial setup
         */
        public override function Begin(game:GameInterface):void
        {
            super.Begin(game);
            mZoom = 1.0
        }

        /**
         *
         */
        protected override function CreateScript():Step
        {
            var steps:Array = [
                new Wait(3),
                new RunFunc(RestartGame),
                ];
            return new Loop(1, steps);
        }

        /**
         * Zoom in on the evil
         */
        public override function Update():void
        {
            super.Update();

            mZoom += Constants.ZOOM_RATE * Time.TimeDelta;

            mGame.SetZoom(mZoom);
        }

        /**
         * restart the game
         */
        private function RestartGame():void
        {
            mGame.SwitchToScript(new Intro());
        }

        /**
         * clean up
         */
        public override function End():void
        {
            super.End();

            mGame.SetZoom(1.0);
        }
    }
}
