﻿package meyermike.script.step 
{
    import meyermike.script.Step;
    
    /**
     * Step to loop a bunch of other steps N times
     * @author Mike Meyer
     */
    public class LoopWhile extends Step
    {
        private var mCondition:Function;
        private var mSteps:/*Step*/Array;
        private var mNextStep:Number;
        
        public function LoopWhile(cond:Function, steps:Array)
        {
            mCondition = cond;
            mNextStep = 0;
            mSteps = steps.concat(); // make a copy
        }
        
        /**
         * Play the next step in the loop
         */
        public override function Execute():Boolean
        {
            // early out if we're done
            if (true != mCondition())
            {
                return true;
            }
            
            // don't crash on empty steplists
            if (0 < mSteps.length)
            {
                var beataction:Step = mSteps[mNextStep];
                
                if (beataction.Execute())
                {
                    ++mNextStep;
                }
                
                if (mNextStep >= mSteps.length)
                {
                    mNextStep = 0;
                }
            }
            
            return false;
        }
    }
    
}